unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ExtCtrls,
  Spin, Menus, LazHelpHTML, unitquestiondlgex;

type
  
  { TForm1 }

  TForm1 = class(TForm)
    Bevel1: TBevel;
    Button1: TButton;
    btnQuestionDlg: TButton;
    DefaultQuestionDlg: TButton;
    cbDefaultFont: TCheckBox;
    cbFontName: TComboBox;
    edX: TEdit;
    edY: TEdit;
    FontDialog1: TFontDialog;
    gbFont: TGroupBox;
    gbMaxWidth: TGroupBox;
    gbTest: TGroupBox;
    gbTestStd: TGroupBox;
    HTMLBrowserHelpViewer1: THTMLBrowserHelpViewer;
    HTMLHelpDatabase1: THTMLHelpDatabase;
    Label1: TLabel;
    Label2: TLabel;
    lblResult: TLabel;
    lblResultStd: TLabel;
    rgGlyphShowMode: TRadioGroup;
    rgMsgType: TRadioGroup;
    rgPosition: TRadioGroup;
    rgBtnAlignment: TRadioGroup;
    rgTextAlignment: TRadioGroup;
    rgButtons: TRadioGroup;
    rgMessage: TRadioGroup;
    seMinWidth: TSpinEdit;
    seFontSize: TSpinEdit;
    seMaxWidth: TSpinEdit;
    procedure Button1Click(Sender: TObject);
    procedure btnQuestionDlgClick(Sender: TObject);
    procedure cbDefaultFontChange(Sender: TObject);
    procedure DefaultQuestionDlgClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

uses
  LCLIntf, LCLType, InterfaceBase, TypInfo, 
  {$IF FPC_FullVersion >= 30200}System.{$IFEND}UITypes;

const
  DLG_TITLE = 'Meine Anfrage';
  MSG_TEXT: array[0..4] of String = (
    'abc',
    'Kurzer Text.',
    'Das ist ein einigermaßen langer Text.',
    'Dies ist ein sehr sehr sehr sehr sehr sehr sehr sehr sehr sehr sehr sehr sehr langer Text',
    'Dies ist ein sehr sehr sehr sehr sehr sehr sehr sehr sehr sehr sehr sehr sehr sehr sehr sehr sehr sehr sehr sehr sehr sehr langer Text'
  );
    
  
{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
var
  msg: String;
  X, Y: Integer;
//  F: TForm;
  mt: TMsgDlgType;
  res: TModalResult;
begin
  lblResult.Caption := '';
  
  QuestionDlgEx_MaxWidth := seMaxWidth.Value;
  QuestionDlgEx_MinWidth := seMinWidth.Value;
  QuestionDlgEx_ButtonAlignment := TAlignment(rgBtnAlignment.ItemIndex);
  QuestionDlgEx_TextAlignment := TAlignment(rgTextAlignment.ItemIndex);
  QuestionDlgEx_GlyphShowMode := TGlyphShowMode(rgGlyphShowMode.ItemIndex);
  if cbDefaultFont.Checked then
  begin
    QuestionDlgEx_FontName := 'default';
    QuestionDlgEx_FontSize := 0;
  end else
  begin
    QuestionDlgEx_FontName := cbFontName.Text;
    QuestionDlgEx_FontSize := seFontSize.Value;
  end;
  
  msg := MSG_TEXT[rgMessage.ItemIndex];
  mt := TMsgDlgType(rgMsgType.ItemIndex);

  if rgPosition.ItemIndex = 0 then
  begin 
    // interpret poDesigned as "missing X and Y", i.e. X := MaxInt; Y := MaxInt; 
    X := MaxInt; 
    Y := MaxInt;
  end else
  if rgPosition.ItemIndex = rgPosition.Items.Count-1 then
  begin
    // last item "custom" means: use X, Y from edit boxes
    if not TryStrToInt(edX.Text, x) then X := MaxInt;
    if not TryStrToInt(edY.Text, Y) then Y := MaxInt;
  end else
  begin
    // These are the "poXXXX" values.
    // Note: The poDefaultXXXX values do not work correctly.
    X := -rgPosition.ItemIndex;
    Y := MaxInt;
  end;
  
//  if cbDefaultFont.Checked then
    case rgButtons.ItemIndex of
      0: res := QuestionDlgEx(DLG_TITLE, msg, mt, [mbYes, 'Ja', 'IsCancel'], 'HTML/index.html', X, Y);
      1: res := QuestionDlgEx(DLG_TITLE, msg, mt, [mbYes, 'Ja', mbNo, 'Nein', 'IsDefault', mbCancel, 'Abbrechen', 'IsCancel'], 'HTML/index.html', X, Y);
      2: res := QuestionDlgEx(DLG_TITLE, msg, mt, [mbYes, 'Ja', mbYesToAll, 'Ja zu allen', mbNo, 'Nein', 'IsDefault', mbNoToAll, 'Nein zu allen', mbCancel, 'Abbruch', 'IsCancel'], 'HTML/index.html', X, Y);
      3: res := QuestionDlgEx(DLG_TITLE, msg, mt, [mbYes, 'Ja', mbYesToAll, 'Ja zu allen', mbNo, 'Nein', 'IsDefault', mbNoToAll, 'Nein zu allen', mbCancel, 'Abbruch', 'IsCancel', mbClose, 'Schließen', mbHelp, 'Hilfe'], 'HTML/index.html', X, Y);
    end;
    {
  else begin
    case rgButtons.ItemIndex of
      0: F := CreateQuestionDlgEx(DLG_TITLE, msg, mt, [mbYes, 'Ja'], 0, X, Y);
      1: F := CreateQuestionDlgEx(DLG_TITLE, msg, mt, [mbYes, 'Ja', mbNo, 'Nein', 'IsDefault', mbCancel, 'Abbrechen'], 0, X, Y);
      2: F := CreateQuestionDlgEx(DLG_TITLE, msg, mt, [mbYes, 'Ja', mbYesToAll, 'Ja zu allen', mbNo, 'Nein', 'IsDefault', mbNoToAll, 'Nein zu allen', mbCancel, 'Abbruch'], 0, X, Y);
      3: F := CreateQuestionDlgEx(DLG_TITLE, msg, mt, [mbYes, 'Ja', mbYesToAll, 'Ja zu allen', mbNo, 'Nein', 'IsDefault', mbNoToAll, 'Nein zu allen', mbCancel, 'Abbruch', mbClose, 'Schließen', mbHelp, 'Hilfe'], 0, X, Y);
      else exit;
    end;
    F.Font.Name := cbFontName.Text;
    F.Font.Size := seFontSize.Value;
    res := F.ShowModal;
    F.Free;
  end;
  }
  
  lblResult.Caption := 'ModalResult: ' + {$IF FPC_FullVersion>=30200}System.{$IFEND}UITypes.ModalResultStr[res];
end;

procedure TForm1.btnQuestionDlgClick(Sender: TObject);
var
  mt: TMsgDlgType;
  res: TModalResult;
begin
  lblResultStd.Caption := '';
  mt := TMsgDlgType(rgMsgType.ItemIndex);
  case rgButtons.ItemIndex of
    0: res := QuestionDlg(DLG_TITLE, MSG_TEXT[rgMessage.ItemIndex], mt, [mbYes, 'Ja'], 'HTML/index.html');
    1: res := QuestionDlg(DLG_TITLE, MSG_TEXT[rgMessage.ItemIndex], mt, [mbYes, 'Ja', mbNo, 'Nein', 'IsDefault', mbCancel, 'Abbrechen'], 'HTML/index.html');
    2: res := QuestionDlg(DLG_TITLE, MSG_TEXT[rgMessage.ItemIndex], mt, [mbYes, 'Ja', mbYesToAll, 'Ja zu allen', mbNo, 'Nein', 'IsDefault', mbNoToAll, 'Nein zu allen', mbCancel, 'Abbruch', 'IsCancel'], 'HTML/index.html');
    3: res := QuestionDlg(DLG_TITLE, MSG_TEXT[rgMessage.ItemIndex], mt, [mbYes, 'Ja', mbYesToAll, 'Ja zu allen', mbNo, 'Nein', 'IsDefault', mbNoToAll, 'Nein zu allen', mbCancel, 'Abbruch', 'IsCancel', mbClose, 'Schließen', mbHelp, 'Hilfe'], 'HTML/index.html');
  end;
  lblResultStd.Caption := 'ModalResult: ' + {$IF FPC_FullVersion>=30200}System.{$IFEND}UITypes.ModalResultStr[res];
end;

procedure TForm1.cbDefaultFontChange(Sender: TObject);
begin
  cbFontName.Enabled := not cbDefaultFont.Checked;
  seFontSize.Enabled := not cbDefaultFont.Checked;
end;

procedure TForm1.DefaultQuestionDlgClick(Sender: TObject);
var
  btns: TDialogButtons;
  res: TModalResult;
  
  procedure AddBtn(ACaption: String; AKind: TModalResult; ADefault: Boolean = false);
  begin
    with btns.Add do
    begin
      Caption := ACaption;
      ModalResult := AKind;
      Default := ADefault;
    end;
  end;
  
begin
  lblResultStd.Caption := '';
  
  btns := TDialogButtons.Create(TDialogButton);
  case rgButtons.ItemIndex of
    0: AddBtn('Ja', mrYes);
    1: begin
         AddBtn('Ja', mrYes);
         AddBtn('Nein', mrNo, true);
         AddBtn('Abbrechen', mrCancel);
       end;
    2: begin
         AddBtn('Ja', mrYes);
         AddBtn('Ja zu allen', mrYesToAll);
         AddBtn('Nein', mrNo, true);
         AddBtn('Nein zu allen', mrNoToAll);
         AddBtn('Abbrechen', mrCancel);
       end;  
    3: begin
         AddBtn('Ja', mrYes);
         AddBtn('Ja zu allen', mrYesToAll);
         AddBtn('Nein', mrNo, true);
         AddBtn('Nein zu allen', mrNoToAll);
         AddBtn('Abbrechen', mrCancel);
         AddBtn('Schließen', mrClose);
         AddBtn('Hilfe', 100);
       end;  
  end;
    
  res := DefaultQuestionDialog(
    DLG_TITLE,
    MSG_TEXT[rgMessage.ItemIndex],
    rgMsgType.ItemIndex + 1 + idDialogBase,
    btns,
    0
  );
  lblResultStd.Caption := 'ModalResult: ' + {$IF FPC_FullVersion>=30200}System.{$IFEND}UITypes.ModalResultStr[res];

  btns.Free;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  cbFontName.Items.Assign(Screen.Fonts);
  cbFontName.ItemIndex := cbFontName.Items.IndexOf('Consolas');;
  cbFontName.Enabled := false;
  seFontSize.Enabled := false;
  lblResult.Caption := '';
  lblResultStd.Caption := '';
end;

end.

